import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.applet.*;
import javax.swing.*;

class Pae {
	int x;
	int y;
	boolean b_pae;
};
	
public class Baduk extends JApplet implements Runnable , ActionListener{
	Image iBoard;
	Image offScrImage; // ۸  
	Image PlayScrImage;

	Image iBack;
	Image iBlack;
	Image iWhite;

	Graphics offScrGC;
	Graphics PlayScrGC;
	Graphics gBoard;

	Font fnt;
	int m_nImgNo;
	int game_state;

	Thread thread;

	JButton btnShowSu;
	int mapSu[][];
	int currentSu;
	boolean b_drawSu;
	int deadBlack;	// 缮 
	int deadWhite;
	JButton btnCalc; // 谡
	JButton btnEndCalc; // 谡


	int map[][];
	int size; 
	int cell;
	int turn;
	public static final int NONE = 0;
	public static final int BLACK = 1;
	public static final int WHITE = 2;
	private String info=""; // 

	// true̸ ڰ    ִ ¸ ǹϰ,
	// false̸ ڰ     ¸ ǹѴ.
	private boolean enable=false;

	private boolean running=false;       //   ΰ Ÿ 

	private PrintWriter writer;            //  ޽ ϱ  Ʈ
	private BufferedReader reader;         // Է Ʈ
	private Socket socket;                 // 

	Pae pae;
	Point link[];
	Point queue[];
	int rear_link;				   //ũ  κ
	int front_que;				   //ť  κ
	int rear_que;				   //ť  κ
	int live;					   //  翩
	int chk_live;				   // ڸ  翩
	int ax, ay;					   //ٵ  ġ
	
	Button startBtn;
	TextField txIP;
    JRootPane cpane;
	JPanel panel;

	Toolkit toolkit = Toolkit.getDefaultToolkit();
	MediaTracker tracker;

	public Image readImageOne( String sImgFileName ) {
		URL MyURL = this.getClass().getResource( sImgFileName );
		Image img = toolkit.getImage( MyURL );
		if( m_nImgNo == 0 )		tracker.addImage(img, 0);
		else					tracker.addImage(img, 1);
		
		m_nImgNo++;
		
		return img;
	}

	public void load_image() {
		int n = 3;

		tracker = new MediaTracker( this );

		m_nImgNo = 0;

		iBack		 = readImageOne( "images/back.gif" );
		iBlack		 = readImageOne( "images/black.gif" );
		iWhite		 = readImageOne( "images/white.gif" );

		try { tracker.waitForAll(); } catch (InterruptedException ie) {};
		while((tracker.statusAll(true) & MediaTracker.COMPLETE) == 0) {};			
	}

	public void connect_screen() {
		iBoard = createImage( 457, 457 );
		gBoard = iBoard.getGraphics();

		cpane = getRootPane();
        setRootPane(cpane);
	    cpane.setOpaque(true);
        cpane.setBackground(Color.white);
  		cpane.setLayout( null );

		btnShowSu = new JButton("̱");
		btnShowSu.addActionListener(this);

		btnShowSu.setBounds( 450, 10, 100, 30 );
		btnShowSu.setVisible(true);
		cpane.add(btnShowSu);

		game_state = 1;
	}

	public void actionPerformed(ActionEvent e) {
		if( btnShowSu.getLabel().equals("̱") ) {
			btnShowSu.setLabel( "߱" );
			b_drawSu = true;
		}
		else {
			btnShowSu.setLabel( "̱" );
			b_drawSu = false;
		}
		repaint();
	}

	public void init_game() {
		size = 19;
		cell = 23;
		turn = BLACK;
		map = new int[size+2][size+2];
		mapSu = new int[size+2][size+2];
		link = new Point[361];
		queue = new Point[361];
		pae = new Pae();
		pae.b_pae = false;
		
		int i, j;

		for( i=0; i<361; i++ ) {
			link[i] = new Point();
			queue[i] = new Point();
		}
		for( i=0; i<size+2; i++ )
			for( j=0; j<size+2; j++ ) {
				map[i][j] = NONE;
				mapSu[i][j] = 0;
			}

		// ٵ 콺 ̺Ʈ ó
		addMouseListener(new MouseAdapter(){
			public void mousePressed(MouseEvent me){     // 콺 
			//if(!enable)return;            // ڰ    ̸  ´.

			// 콺 ǥ map ǥ Ѵ.
			ax=(int)Math.round(me.getX()/(double)cell);
			ay=(int)Math.round(me.getY()/(double)cell);

			//    ִ ǥ ƴϸ  ´.
			if(ax<=0 || ay<=0 || ax>=size+1 || ay>=size+1)return;

			// ش ǥ ٸ     ´.
			if(map[ax][ay]==BLACK || map[ax][ay]==WHITE)return;

			//  Ȯ
			if(pae.b_pae==true)	{
				if((pae.x==ax) && (pae.y==ay))	return ;
				else if ((pae.x!=ax) || (pae.y!=ay)) pae.b_pae = false;
			}

			chk_live = 0;

			if ( isBlackTurn() ) {
				chk_live += AllCheck(ax-1, ay, ax, ay, BLACK);
				chk_live += AllCheck(ax+1, ay, ax, ay, BLACK);
				chk_live += AllCheck(ax, ay-1, ax, ay, BLACK);
				chk_live += AllCheck(ax, ay+1, ax, ay, BLACK);
			}
			if( isWhiteTurn() )	{
				chk_live += AllCheck(ax-1, ay, ax, ay, WHITE);
				chk_live += AllCheck(ax+1, ay, ax, ay, WHITE);
				chk_live += AllCheck(ax, ay-1, ax, ay, WHITE);
				chk_live += AllCheck(ax, ay+1, ax, ay, WHITE);
			}

			if (chk_live==0) return;
			

			map[ax][ay]=turn;
			mapSu[ax][ay] = ++currentSu;
			change_turn();

			}
		});
	}

	public void drawSu() {
		int aax=0;

		if( b_drawSu ) {
			for(int x=1; x<=size;x++)
				for(int y=1; y<=size;y++)
					if(map[x][y]!=NONE) {
						if( map[x][y] == BLACK )
							gBoard.setColor(Color.white);
						else
							gBoard.setColor(Color.black);
						if( mapSu[x][y] >= 100 ) aax = x*cell-cell/2+1;
						else if( mapSu[x][y] >= 10 ) aax = x*cell-cell/2+4;
						else aax = x*cell-cell/2+8;
						gBoard.drawString( String.valueOf(mapSu[x][y]), aax, y*cell-cell/2+14);	
					}
		}
		else {
			int xx[] = {ax*cell-cell/2+5, ax*cell-cell/2+14+5, ax*cell-cell/2+7+5};
			int yy[] = {ay*cell-cell/2+12, ay*cell-cell/2+12, ay*cell-cell/2+7+12};

			if( currentSu != 0 ) {
				if( map[ax][ay]== BLACK )
					gBoard.setColor(Color.yellow);
				else
					gBoard.setColor(Color.black);
				gBoard.fillPolygon(xx, yy, 3);
			}
		}
	}

	private void drawStones() { // map    ׸.
		for(int x=1; x<=size;x++)
			for(int y=1; y<=size;y++){
				if(map[x][y]==BLACK)
					gBoard.drawImage( iBlack, x*cell-cell/2, y*cell-cell/2, null);
				else if(map[x][y]==WHITE)
					gBoard.drawImage( iWhite, x*cell-cell/2, y*cell-cell/2, null);
			} 
	}

	public void draw_board() {
		try
		{
			
		int i, j;	
		String sco1, sco2;
	
		//  ̹ Ѹ.
		gBoard.clearRect(0, 0, 457, 457);
		gBoard.drawImage( iBack, 0, 0, null );

		drawStones();
		drawSu();
		Graphics g = getGraphics();
		
		if( iBoard == null ) return;
		g.drawImage( iBoard, 0, 0, null );
		}
		catch (Exception e)
		{
			System.out.println( "draw_board() : " +e);
		}
	}

	//   ƾ
	public void run() {
		while ( thread != null ) {
			switch(game_state) {
				case 0 :
					break;
				case 1:
					draw_board();
					break;
				default :
					break;
			}
		}
	}
	

	void CheckLink(int _x, int _y, int turn) {
		//¿    ť ϴ Լ ȣ
		if ((_x-1>0)	  && (map[_x-1][_y]==turn))	Insert_que(_x-1, _y);
		if ((_x+1<size+1) && (map[_x+1][_y]==turn))	Insert_que(_x+1, _y);
		if ((_y-1>0)	  && (map[_x][_y-1]==turn))	Insert_que(_x, _y-1);
		if ((_y+1<size+1) && (map[_x][_y+1]==turn))	Insert_que(_x, _y+1);
	}

	void Insert_que(int _x, int _y) {
		//̹ ϵ ť ߺ Ǿ üũ
		for (int i=0; i<rear_que; i++)
			if ((queue[i].x==_x) && (queue[i].y==_y)) return;
		
		//ߺ  ť  
		queue[rear_que].x = _x;
		queue[rear_que].y = _y;
		++rear_que;
	}

	void Insert_link()
	{
		//̹ ϵ ũ ߺ Ǿ üũ
		for (int i=0; i<rear_link; i++)
			if ((link[i].x==queue[front_que].x) && (link[i].y==queue[front_que].y))
				return;

		//ߺ  ť ù°  ũ 
		link[rear_link].x = queue[front_que].x;
		link[rear_link].y = queue[front_que].y;
		++rear_link;
		++front_que;
	}	

	void CheckLive(int _x, int _y)
	{
		live = 0;
		for (int i=0; i<rear_link; i++)	{
			if ((map[link[i].x-1][link[i].y]==NONE) && (link[i].x-1>0))
				if ((link[i].x-1==_x) && (link[i].y==_y)){ } // ڸ  ʴ´
				else 	++live; 
			if ((map[link[i].x+1][link[i].y]==NONE) && (link[i].x+1<size+1))
				if ((link[i].x+1==_x) && (link[i].y==_y)){	}
				else	++live;
			if ((map[link[i].x][link[i].y-1]==NONE) && (link[i].y-1>0))
				if ((link[i].x==_x) && (link[i].y-1==_y)){	}
				else	++live;
			if ((map[link[i].x][link[i].y+1]==NONE) && (link[i].y+1<size+1))
				if ((link[i].x==_x) && (link[i].y+1==_y)){	}
				else	++live;
		}
	}

	void RemoveDead(){
		if (live==0) {
			CheckPae();  //  üũѴ
			for (int i=0; i<rear_link; i++) // Ѵ
				map[(link[i].x)][(link[i].y)] = NONE;
		}
	}

	int AllCheck(int user_x, int user_y, int _x, int _y, int turn)	{
		if ((map[user_x][user_y]!=NONE) && (user_x>0) && (user_x<size+1) && (user_y>0) && (user_y<size+1))	{
			rear_link = 0;
			front_que = 0;
			rear_que = 0;
			Insert_que(user_x, user_y);
			while (front_que!=rear_que)	{
				CheckLink(queue[front_que].x, queue[front_que].y, map[user_x][user_y]);
				Insert_link();
			}
			CheckLive(_x, _y);
			if ((map[user_x][user_y]!=turn) && (live==0))	{
				RemoveDead();
				return 1;
			}
			else if ((map[user_x][user_y]==turn) && (live>0)) 		return 1;
			else		return 0;
		}
		else if ((map[user_x][user_y]==NONE) && (user_x>0) && (user_x<size+1) && (user_y>0) && (user_y<size+1))
			return 1;
		else	return 0;
	}

	void CheckPae() {
		int turn;
		int tmp_live=0;
		// ÷̾ ¿ ݴ
		if( isBlackTurn() ) turn = WHITE;
		else turn = BLACK;

		if(rear_link==1) {
			// ڸ ¿ üũ
			if((ax-1<=0)	  || (map[ax-1][ay]==turn))	++tmp_live;
			if((ax+1>=size+1) || (map[ax+1][ay]==turn))	++tmp_live;
			if((ay-1<=0)	  || (map[ax][ay-1]==turn))	++tmp_live;
			if((ay+1>=size+1) || (map[ax][ay+1]==turn))	++tmp_live;
			if(tmp_live==4){ // ڸ   
				pae.b_pae = true;
				pae.x = link[0].x;
				pae.y = link[0].y;
			}
		}
	}
	
	public boolean isBlackTurn() {
		if( turn == BLACK ) return true;
		return false;
	}

	public boolean isWhiteTurn() {
		if( turn == WHITE ) return true;
		return false;
	}

	public void change_turn() {
		if( turn == BLACK ) turn = WHITE;
		else turn = BLACK;
	}

	// ø  εǴ 
	public void init() { 
		load_image(); // ׸ ҷ´.
		init_game();
		connect_screen();
	}

	// ø Ǿ  
	public void start() {
		if( thread == null ){ 
			thread = new Thread(this); 
			thread.start(); 
		}
	}

	// ø  Ǵ 
	// destroy()  ȣǱ  ȣ
	public void stop() {
		thread = null;
	}

	// ø ıϰ, ϰ ִ  ҽ  ȴ.
	// ø 
	public void destroy() {
	}
	public void update(Graphics g) { //repaint() ȣϸ ڵȣ
		paint(g);
	}

	// ø ŵǰų  ׷   óϴ ޼ҵ
	public void paint(Graphics g) { // ȭ ׸.
		if( iBoard == null ) return;
		g.drawImage( iBoard, 0, 0, null );
	}
}